def explore_tunnel(img, cur_i, cur_j):
    
    i,j = cur_i, cur_j        
    n_rows,n_cols = img.shape
        
    # determine the entry/exit
    if i in [0,n_rows-1] or j in [0,n_cols-1]:
        entry_i = i
        entry_j = j
    elif sum(img[i:n_rows,j]!=1) == n_rows-i:
        entry_i = n_rows - 1
        i = entry_i
        entry_j = j
    elif sum(img[i,j:n_cols]!=1) == n_cols-j:
        entry_i = i
        entry_j = n_cols - 1
        j = entry_j
    
    tunnel_size = 1    
    img[i,j] = 1
    
    while (i==entry_i and j==entry_j) or (i not in [0, n_rows-1] and j not in [0, n_cols-1]):
    
        # try four choices
        if img[i, max(0, j-1)] != 1: # left
            j = max(0, j-1)
        elif img[i, min(j+1, n_cols-1)] != 1: # right
            j = min(j+1, n_cols-1)
        elif img[max(0, i-1),j] != 1: # top
            i = max(0, i - 1)
        elif img[min(i+1,n_rows-1), j] != 1: # bottom
            i = min(i + 1, n_rows-1)
        
        img[i,j] = 1        
        tunnel_size += 1
        
    exit_i = i
    exit_j = j    
    return (tunnel_size, (entry_i, entry_j), (exit_i, exit_j))

# for showing intermediate image only (not required in the exam)
def imshow(img):
    if (img!=1).any():
        plt.imshow(img, cmap="gray")
        ax = plt.gca()
        ax.set_xticks(np.arange(0,10))
        ax.set_yticks(np.arange(0,10))                    
        plt.grid(b=True, which='both', color='b')
        plt.show()    
    

def count_tunnels(img):
    background=1
    nb_tunnels = 0    
    n_rows,n_cols = img.shape        
    
    tunnels_info = []
    
    imshow(img)
    
    for i in range(n_rows):
        for j in range(n_cols):
    
            if img[i,j] != background:                  
                
                nb_tunnels += 1
                
                tunnel_size, (entry_i,entry_j), (exit_i,exit_j) = explore_tunnel(img, i, j)

                tunnels_info.append((tunnel_size, (entry_i,entry_j), (exit_i,exit_j)))
                
                imshow(img)
                
    return tunnels_info

import numpy as np
import skimage.io as io
from skimage.color import rgb2gray
import matplotlib.pyplot as plt

img = rgb2gray(io.imread("maze.eps"))

print(count_tunnels(img))








